searchNodes=[{"doc":"Call the use ExTenant macro to inject all the required behaviour into your Application Repo module to enable all multi-tenancy functions.Setup In your application Repo file call the use macro as per this exampledef YourApplication.Repo do use ExTenant, config: [ otp_app: :name_of_your_elixir_phoenix_app_as_atom, adapter: Ecto.Adapters.Postgres, tenanted_field: &quot;tenant_id&quot; ] end In order to get the tenant_id into the progress dictionary in Phoenix we recommend to use a plug - there you should retrieve the tenant name from something like the sub domain in the url. Then using the tenant name retrieve the tenant, and call:Repo.put_tenant_id(tenant_id) To insert the tenant_id into the process dictionary.Plug (The next version of this library will provide a Plug that you can use. Watch this space!) From here all your Repo callbacks (Repo.get/Repo.one/Repo.all etc) will have a where clause applied to them with the tenant_id injected into the clause. In order to set the tenant_id on insert and update functions the tenant_id needs to be inserted into the attributes to be inserted. The tenanted_schema macro &amp; the tenanted() function inserts the correct belongs_to tenanted foreign key based relationship. Further the cast_tenant method overloads the standard Ecto.Changeset.cast function by injecting the tenant_id into the params and allowed keys. This function raises exceptions when the Repo was not configured correctly in config.exs and also if the tenant_id value is not set in the process_dictionary.Ecto Schema/Changesetdefmodule Post do use ExTenant.Schema use ExTenant.Changeset tenanted_schema &quot;posts&quot; do field(:name, :string) field(:body, :string) tenanted() end defp changeset(attrs) do %__MODULE__{} |&gt; cast_tenanted(params, [:name, :body]) end end NB: If the tenant_id is not set in the changeset, Repo.insert/update callbacks will raise a Postgrex.Error (not_null_violation)Migrationsdocumentation to be added.","ref":"ExTenant.html","title":"ExTenant","type":"module"},{"doc":"Run the tenanted migrations","ref":"ExTenant.Actions.html","title":"ExTenant.Actions","type":"module"},{"doc":"Apply tenant migrations to a tenant with given strategy, in given direction.A direction can be given, as the third parameter, which defaults to :up A strategy can be given as an option, and defaults to :allParamatersrepo: the repository we are running the migrations fordirection: defaults to :upOptions:all - runs all available if true:step - runs the specific number of migrations:to - runs all until the supplied version is reached:log - the level to use for logging. Defaults to :info. Can be any of Logger.level/0 values or false.","ref":"ExTenant.Actions.html#migrate_tenanted/3","title":"ExTenant.Actions.migrate_tenanted/3","type":"function"},{"doc":"The function cast_tenanted(changset, attrs, allowed)injects the tenant_id key/atom into the allowed fieldsretrieves the tenant_id value from the process dictionaryinjects the %{&quot;tenant_id&quot; =&gt; tenant_id} into the attrs mapand then calls the standard Ecto.Changeset.cast function An exception will be raised in the following two situationsif the Repo was not set in the Config.exs fileif the tenant_id in the process dictionary is nilHere is an exampledefmodule Post do use ExTenant.Schema use ExTenant.Changeset ... defp changeset(attrs) do %__MODULE__{} |&gt; cast_tenanted(params, [:name, :body]) end end","ref":"ExTenant.Changeset.html","title":"ExTenant.Changeset","type":"module"},{"doc":"Basically call this like the standard cast function and the module macros will handle all the tenant_id injectingExampledef changeset(attrs) do %__MODULE__{} |&gt; cast_tenanted(attrs, [:name, :body]) end","ref":"ExTenant.Changeset.html#cast_tenanted/3","title":"ExTenant.Changeset.cast_tenanted/3","type":"macro"},{"doc":"retrieve the tenanted migrations path using a default fallback","ref":"ExTenant.PathHelper.html","title":"ExTenant.PathHelper","type":"module"},{"doc":"## Parameters- *repo* : the repository th retrieve the path for","ref":"ExTenant.PathHelper.html#tenanted_migrations_path/1","title":"ExTenant.PathHelper.tenanted_migrations_path/1","type":"function"},{"doc":"To use the Extenant.Schema in your schema modulesit injects the belongs_to relationship to the tenantit also raises a compiler error if the tenanted() call was omittedit works with the tenant_id field set in Config.exsHere is an exampledefmodule Post do use ExTenant.Schema use ExTenant.Changeset tenanted_schema &quot;posts&quot; do field(:name, :string) field(:body, :string) tenanted() end end","ref":"ExTenant.Schema.html","title":"ExTenant.Schema","type":"module"},{"doc":"injects belongs_to relationship to the tenant modelExampletenanted_schema &quot;posts&quot; do field(:name, :string) tenanted() end","ref":"ExTenant.Schema.html#tenanted/0","title":"ExTenant.Schema.tenanted/0","type":"macro"},{"doc":"Replaces Ecto.Schema.embedded_schema/2 - checking whether tenanted() has been called - that injects the belongs_to tenant relationship","ref":"ExTenant.Schema.html#tenanted_embedded_schema/1","title":"ExTenant.Schema.tenanted_embedded_schema/1","type":"macro"},{"doc":"Replaces Ecto.Schema.schema/2 - checking whether tenanted() has been called - that injects the belongs_to tenant relationship","ref":"ExTenant.Schema.html#tenanted_schema/2","title":"ExTenant.Schema.tenanted_schema/2","type":"macro"},{"doc":"Generates a migration. The repository must be set under :ecto_repos in the current app configuration or given via the -r option. ## Examples mix ex_tenant.gen.migration add_posts_table mix ex_tenant.gen.migration add_posts_table -r Custom.Repo By default, the migration will be generated to the &quot;priv/YOUR_REPO/tenant_migrations&quot; directory of the current application. It can be configured to be any subdirectory of priv by specifying the :priv key under the repository configuration.## Command line options * `-r`, `--repo` - the repo to generate migration for","ref":"Mix.Tasks.ExTenant.Gen.Migration.html","title":"Mix.Tasks.ExTenant.Gen.Migration","type":"task"},{"doc":"ExTenant","ref":"readme.html","title":"ExTenant","type":"extras"},{"doc":"","ref":"readme.html#multi-tenancy-library-based-on-foreign-key-relationship","title":"ExTenant - Multi Tenancy Library - based on foreign key relationship","type":"extras"},{"doc":"Overrides the Ecto callback default_options to inject the tenant_idOverrides the Ecto callback prepare_query to inject the tenant_id into a where clause","ref":"readme.html#features-for-querying-the-database","title":"ExTenant - Features for Querying the database","type":"extras"},{"doc":"The package can be installed by adding ex_tenant to your list of dependencies in mix.exs:def deps do [ {:ex_tenant, &quot;~&gt; 0.1.1&quot;} ] endRun: mix deps.get &amp;&amp; mix deps.compile to retrieve dependencies &amp; compile","ref":"readme.html#installation","title":"ExTenant - Installation","type":"extras"}]